#include<bits/stdc++.h>

using namespace std;

typedef long long LL;
//typedef __int128 LL;


const int MAXN = 1 << 19;
const int MOD = 1000000007;


struct grow {
	int v;
	int k;
	int ks;
	LL s;

	grow(int a, int b, int c, LL d)
		: v(a), k(b), ks(c), s(d) {}
};

struct gcd_seg {
	int g;
	int j;

	gcd_seg(int a, int b)
		: g(a), j(b) {}
};



int t[MAXN * 3];
int a[MAXN];
int lf;


void initLeaf(int n) {
	if (n & (n - 1)) {
		frexp(n, &n);
		n = 1 << n;
	}

	lf = n;
}


int gcd(int a, int b) {
	while (b > 0)
		swap(a %= b, b);

	return a;
}


int queryGcd(int a, int b) {
	if (b < a)
		return 0;

	a += lf;
	b += lf;

	int res = t[a];

	while (a < b) {
		if (a % 2 == 1)
			res = gcd(res, t[a++]);

		if (b % 2 == 0)
			res = gcd(res, t[b--]);

		a /= 2;
		b /= 2;
	}

	if (a == b)
		res = gcd(res, t[a]);

	return res;
}


void initTree(int n) {
	initLeaf(n);

	for (int i = lf; i < lf * 2; ++i) {
		t[i] = a[i - lf];
	}

	for (int i = lf - 1; i > 0; --i) {
		t[i] = gcd(t[i * 2], t[i * 2 + 1]);
	}
}


void updateGrow(deque<grow>& q, LL v) {
	LL k = 1;

	while (!q.empty() && q.front().v <= v) {
		const grow& g = q.front();

		k += g.k;
		q.pop_front();
	}

	LL sp = (q.empty() ? 0LL : q.front().s);
	int sk = (q.empty() ? 0 : q.front().ks);

	q.push_front(grow(v, k, sk + k, v * k + sp));
}


int binSearchMax(const deque<grow>& qq, int kx) {
	int p = 0;
	int q = qq.size() - 1;

	while (p <= q) {
		int m = (p + q) / 2;

		if (qq[m].ks >= kx) {
			p = m + 1;
		}
		else {
			q = m - 1;
		}
	}

	return q;
}


LL queryMaxSum(const deque<grow>& q, int k) {
	int x = binSearchMax(q, k);
	const grow& g = q[x];

	LL r = (g.ks - k) * g.v;

	return g.s - r;
}

gcd_seg binSearchChange(int n, int j, int g) {
	int p = j + 1;
	int q = n - 1;

	while (p <= q) {
		int m = (p + q) / 2;

		if (queryGcd(j, m) == g)
			p = m + 1;
		else
			q = m - 1;
	}

	return gcd_seg(queryGcd(j, p), p);
}

vector<gcd_seg> getGcdChanges(int n, int j) {
	int g = a[j];
	vector<gcd_seg> s;

	s.push_back(gcd_seg(g, j));

	while (g > 1) {
		gcd_seg x = binSearchChange(n, j, g);

		if (x.j >= n)
			break;

		s.push_back(x);
		g = x.g;
		j = x.j;
	}

	return s;
}


LL querySums(int n, const deque<grow>& q, int j) {
	LL res = 0;

	vector<gcd_seg> dd = getGcdChanges(n, j);
	vector<LL> maxSum;

	int sz = dd.size();

	for (int i = 0; i < sz; ++i) {
		LL ds = queryMaxSum(q, n - dd[i].j);
		maxSum.push_back(ds);
	}

	maxSum.push_back(0);

	for (int i = 0; i < sz; ++i) {
		res += (max(0, maxSum[i] - maxSum[i + 1])) * dd[i].g;
	}

	return res;
}


LL bsum(int n) {
	LL res = 0;
	deque<grow> q;

	for (int i = n - 1; i >= 0; --i) {
		cerr << "Start point is: " << i << endl;
		updateGrow(q, a[i]);

		LL delta = querySums(n, q, i);

		cerr << "Current delta is: " << delta << endl;
		res += delta;
	}

	return res;
}


int main() {
    ios_base::sync_with_stdio(0);
	cin.tie(0);

	int xxx;

	int n;
	cin >> xxx;
	n = xxx;

	for (int i = 0; i < n; ++i) {
		cin >> xxx;
		a[i] = xxx;
	}

	initTree(n);

	LL ans = bsum(n);
	ans %= MOD;

	long long res = ans;

	cout << res << endl;

	return 0;
}
